Index: trunk/LMDZ.GENERIC/libf/phystd/physiq.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 787)
@@ -1,3 +1,4 @@
       subroutine physiq(ngrid,nlayer,nq,   &
+                  nametrac,                & 
                   firstcall,lastcall,      &
                   pday,ptime,ptimestep,    &
@@ -13,4 +14,11 @@
       use radii_mod, only: h2o_reffrad, co2_reffrad
       use aerosol_mod
+      use surfdat_h
+      use comdiurn_h
+      use comsaison_h
+      use comsoil_h
+      USE comgeomfi_h
+      USE tracer_h
+
       implicit none
 
@@ -103,4 +111,5 @@
 !           New turbulent diffusion scheme: J. Leconte (2012)
 !           Loops converted to F90 matrix format: J. Leconte (2012)
+!           No more ngridmx/nqmx, F90 commons and adaptation to parallel: A. Spiga (2012)
 !     
 !==================================================================
@@ -112,15 +121,8 @@
 #include "dimensions.h"
 #include "dimphys.h"
-#include "comgeomfi.h"
-#include "surfdat.h"
-#include "comsoil.h"
-#include "comdiurn.h"
 #include "callkeys.h"
 #include "comcstfi.h"
 #include "planete.h"
-#include "comsaison.h"
 #include "control.h"
-#include "tracer.h"
-#include "watercap.h"
 #include "netcdf.inc"
 
@@ -132,10 +134,10 @@
       integer ngrid,nlayer,nq
       real ptimestep
-      real pplev(ngridmx,nlayer+1),pplay(ngridmx,nlayer)
-      real pphi(ngridmx,nlayer)
-      real pu(ngridmx,nlayer),pv(ngridmx,nlayer)
-      real pt(ngridmx,nlayer),pq(ngridmx,nlayer,nq)
-      real pw(ngridmx,nlayer)        ! pvervel transmitted by dyn3d
-      real zh(ngridmx,nlayermx)      ! potential temperature (K)
+      real pplev(ngrid,nlayer+1),pplay(ngrid,nlayer)
+      real pphi(ngrid,nlayer)
+      real pu(ngrid,nlayer),pv(ngrid,nlayer)
+      real pt(ngrid,nlayer),pq(ngrid,nlayer,nq)
+      real pw(ngrid,nlayer)        ! pvervel transmitted by dyn3d
+      real zh(ngrid,nlayermx)      ! potential temperature (K)
       logical firstcall,lastcall
 
@@ -144,10 +146,12 @@
       logical tracerdyn
 
+      character*20 nametrac(nq)   ! name of the tracer from dynamics
+
 !   outputs:
 !   --------
 !     physical tendencies
-      real pdu(ngridmx,nlayer),pdv(ngridmx,nlayer)
-      real pdt(ngridmx,nlayer),pdq(ngridmx,nlayer,nq)
-      real pdpsrf(ngridmx) ! surface pressure tendency
+      real pdu(ngrid,nlayer),pdv(ngrid,nlayer)
+      real pdt(ngrid,nlayer),pdq(ngrid,nlayer,nq)
+      real pdpsrf(ngrid) ! surface pressure tendency
 
 
@@ -157,30 +161,26 @@
 !     "longrefvis" set in dimradmars.h , for one of the "naerkind"  kind of
 !      aerosol optical properties:
-!      real aerosol(ngridmx,nlayermx,naerkind) 
+!      real aerosol(ngrid,nlayermx,naerkind) 
 !     this is now internal to callcorrk and hence no longer needed here
 
       integer day_ini                ! Initial date of the run (sol since Ls=0) 
       integer icount                 ! counter of calls to physiq during the run.
-      real tsurf(ngridmx)            ! Surface temperature (K)
-      real tsoil(ngridmx,nsoilmx)    ! sub-surface temperatures (K)
-      real albedo(ngridmx)           ! Surface albedo
-
-      real albedo0(ngridmx)          ! Surface albedo
-      integer rnat(ngridmx)          ! added by BC
-      save rnat
-
-      real emis(ngridmx)             ! Thermal IR surface emissivity
-      real dtrad(ngridmx,nlayermx)   ! Net atm. radiative heating rate (K.s-1)
-      real fluxrad_sky(ngridmx)      ! rad. flux from sky absorbed by surface (W.m-2)
-      real fluxrad(ngridmx)          ! Net radiative surface flux (W.m-2)
-      real capcal(ngridmx)           ! surface heat capacity (J m-2 K-1)
-      real fluxgrd(ngridmx)          ! surface conduction flux (W.m-2)
-      real qsurf(ngridmx,nqmx)       ! tracer on surface (e.g. kg.m-2)
-      real q2(ngridmx,nlayermx+1)    ! Turbulent Kinetic Energy 
+      real, dimension(:),allocatable,save ::  tsurf  ! Surface temperature (K)
+      real, dimension(:,:),allocatable,save ::  tsoil  ! sub-surface temperatures (K)
+      real, dimension(:),allocatable,save :: albedo ! Surface albedo
+
+      real,dimension(:),allocatable,save :: albedo0 ! Surface albedo
+      integer,dimension(:),allocatable,save :: rnat ! added by BC
+
+      real,dimension(:),allocatable,save :: emis ! Thermal IR surface emissivity
+      real,dimension(:,:),allocatable,save :: dtrad ! Net atm. radiative heating rate (K.s-1)
+      real,dimension(:),allocatable,save :: fluxrad_sky ! rad. flux from sky absorbed by surface (W.m-2)
+      real,dimension(:),allocatable,save :: fluxrad ! Net radiative surface flux (W.m-2)
+      real,dimension(:),allocatable,save :: capcal ! surface heat capacity (J m-2 K-1)
+      real,dimension(:),allocatable,save :: fluxgrd ! surface conduction flux (W.m-2)
+      real,dimension(:,:),allocatable,save :: qsurf ! tracer on surface (e.g. kg.m-2)
+      real,dimension(:,:),allocatable,save :: q2 ! Turbulent Kinetic Energy 
 
       save day_ini, icount
-      save tsurf,tsoil
-      save albedo0,albedo,emis,q2
-      save capcal,fluxgrd,dtrad,fluxrad,fluxrad_sky,qsurf
 
 ! Local variables :
@@ -189,80 +189,75 @@
 !     aerosol (dust or ice) extinction optical depth  at reference wavelength 
 !     for the "naerkind" optically active aerosols:
-      real aerosol(ngridmx,nlayermx,naerkind) 
+      real aerosol(ngrid,nlayermx,naerkind) 
 
       character*80 fichier 
       integer l,ig,ierr,iq,iaer
 
-      real fluxsurf_lw(ngridmx)      ! incident LW (IR) surface flux (W.m-2)
-      real fluxsurf_sw(ngridmx)      ! incident SW (stellar) surface flux (W.m-2)
-      real fluxtop_lw(ngridmx)       ! Outgoing LW (IR) flux to space (W.m-2)
-      real fluxabs_sw(ngridmx)       ! Absorbed SW (stellar) flux (W.m-2)
-
-      real fluxtop_dn(ngridmx)
-      real fluxdyn(ngridmx)          ! horizontal heat transport by dynamics      
-      real OLR_nu(ngridmx,L_NSPECTI)! Outgoing LW radition in each band (Normalized to the band width (W/m2/cm-1)
-      real OSR_nu(ngridmx,L_NSPECTV)! Outgoing SW radition in each band (Normalized to the band width (W/m2/cm-1)
- 
-      real,save :: sensibFlux(ngridmx)   ! turbulent flux given by the atm to the surface
- 
-      save fluxsurf_lw,fluxsurf_sw,fluxtop_lw,fluxabs_sw,fluxtop_dn,fluxdyn,OLR_nu,OSR_nu
-
+      !!! this is saved for diagnostic
+      real,dimension(:),allocatable,save :: fluxsurf_lw ! incident LW (IR) surface flux (W.m-2)
+      real,dimension(:),allocatable,save :: fluxsurf_sw ! incident SW (stellar) surface flux (W.m-2)
+      real,dimension(:),allocatable,save :: fluxtop_lw ! Outgoing LW (IR) flux to space (W.m-2)
+      real,dimension(:),allocatable,save :: fluxabs_sw ! Absorbed SW (stellar) flux (W.m-2)
+      real,dimension(:),allocatable,save :: fluxtop_dn
+      real,dimension(:),allocatable,save :: fluxdyn ! horizontal heat transport by dynamics  
+      real,dimension(:,:),allocatable,save :: OLR_nu ! Outgoing LW radition in each band (Normalized to the band width (W/m2/cm-1)
+      real,dimension(:,:),allocatable,save :: OSR_nu ! Outgoing SW radition in each band (Normalized to the band width (W/m2/cm-1)
+      real,dimension(:,:),allocatable,save :: zdtlw ! (K/s)
+      real,dimension(:,:),allocatable,save :: zdtsw ! (K/s)
+      real,dimension(:),allocatable,save :: sensibFlux ! turbulent flux given by the atm to the surface
 
       real zls                       ! solar longitude (rad)
       real zday                      ! date (time since Ls=0, in martian days)
-      real zzlay(ngridmx,nlayermx)   ! altitude at the middle of the layers
-      real zzlev(ngridmx,nlayermx+1) ! altitude at layer boundaries
+      real zzlay(ngrid,nlayermx)   ! altitude at the middle of the layers
+      real zzlev(ngrid,nlayermx+1) ! altitude at layer boundaries
       real latvl1,lonvl1             ! Viking Lander 1 point (for diagnostic)
 
 !     Tendencies due to various processes:
-      real dqsurf(ngridmx,nqmx)
-      real,save :: zdtlw(ngridmx,nlayermx)                    ! (K/s)
-      real,save :: zdtsw(ngridmx,nlayermx)                    ! (K/s)
-
-      real cldtlw(ngridmx,nlayermx)                           ! (K/s) LW heating rate for clear areas
-      real cldtsw(ngridmx,nlayermx)                           ! (K/s) SW heating rate for clear areas
-      real zdtsurf(ngridmx)                                   ! (K/s)
-      real dtlscale(ngridmx,nlayermx)
-      real zdvdif(ngridmx,nlayermx),zdudif(ngridmx,nlayermx)  ! (m.s-2)
-      real zdhdif(ngridmx,nlayermx), zdtsdif(ngridmx)         ! (K/s)
-      real zdtdif(ngridmx,nlayermx)			      ! (K/s)
-      real zdvadj(ngridmx,nlayermx),zduadj(ngridmx,nlayermx)  ! (m.s-2)
-      real zdhadj(ngridmx,nlayermx)                           ! (K/s)
-      real zdtgw(ngridmx,nlayermx)                            ! (K/s)
-      real zdtmr(ngridmx,nlayermx)
-      real zdugw(ngridmx,nlayermx),zdvgw(ngridmx,nlayermx)    ! (m.s-2)
-      real zdtc(ngridmx,nlayermx),zdtsurfc(ngridmx)
-      real zdvc(ngridmx,nlayermx),zduc(ngridmx,nlayermx)
-      real zdumr(ngridmx,nlayermx),zdvmr(ngridmx,nlayermx)
-      real zdtsurfmr(ngridmx)
+      real dqsurf(ngrid,nq)
+      real cldtlw(ngrid,nlayermx)                           ! (K/s) LW heating rate for clear areas
+      real cldtsw(ngrid,nlayermx)                           ! (K/s) SW heating rate for clear areas
+      real zdtsurf(ngrid)                                   ! (K/s)
+      real dtlscale(ngrid,nlayermx)
+      real zdvdif(ngrid,nlayermx),zdudif(ngrid,nlayermx)  ! (m.s-2)
+      real zdhdif(ngrid,nlayermx), zdtsdif(ngrid)         ! (K/s)
+      real zdtdif(ngrid,nlayermx)			      ! (K/s)
+      real zdvadj(ngrid,nlayermx),zduadj(ngrid,nlayermx)  ! (m.s-2)
+      real zdhadj(ngrid,nlayermx)                           ! (K/s)
+      real zdtgw(ngrid,nlayermx)                            ! (K/s)
+      real zdtmr(ngrid,nlayermx)
+      real zdugw(ngrid,nlayermx),zdvgw(ngrid,nlayermx)    ! (m.s-2)
+      real zdtc(ngrid,nlayermx),zdtsurfc(ngrid)
+      real zdvc(ngrid,nlayermx),zduc(ngrid,nlayermx)
+      real zdumr(ngrid,nlayermx),zdvmr(ngrid,nlayermx)
+      real zdtsurfmr(ngrid)
       
-      real zdmassmr(ngridmx,nlayermx),zdpsrfmr(ngridmx)
-
-      real zdqdif(ngridmx,nlayermx,nqmx), zdqsdif(ngridmx,nqmx)
-      real zdqevap(ngridmx,nlayermx)
-      real zdqsed(ngridmx,nlayermx,nqmx), zdqssed(ngridmx,nqmx)
-      real zdqdev(ngridmx,nlayermx,nqmx), zdqsdev(ngridmx,nqmx)
-      real zdqadj(ngridmx,nlayermx,nqmx)
-      real zdqc(ngridmx,nlayermx,nqmx)
-      real zdqmr(ngridmx,nlayermx,nqmx),zdqsurfmr(ngridmx,nqmx)
-      real zdqlscale(ngridmx,nlayermx,nqmx)
-      real zdqslscale(ngridmx,nqmx)
-      real zdqchim(ngridmx,nlayermx,nqmx)
-      real zdqschim(ngridmx,nqmx)
-
-      real zdteuv(ngridmx,nlayermx)    ! (K/s)
-      real zdtconduc(ngridmx,nlayermx) ! (K/s)
-      real zdumolvis(ngridmx,nlayermx)
-      real zdvmolvis(ngridmx,nlayermx)
-      real zdqmoldiff(ngridmx,nlayermx,nqmx)
+      real zdmassmr(ngrid,nlayermx),zdpsrfmr(ngrid)
+
+      real zdqdif(ngrid,nlayermx,nq), zdqsdif(ngrid,nq)
+      real zdqevap(ngrid,nlayermx)
+      real zdqsed(ngrid,nlayermx,nq), zdqssed(ngrid,nq)
+      real zdqdev(ngrid,nlayermx,nq), zdqsdev(ngrid,nq)
+      real zdqadj(ngrid,nlayermx,nq)
+      real zdqc(ngrid,nlayermx,nq)
+      real zdqmr(ngrid,nlayermx,nq),zdqsurfmr(ngrid,nq)
+      real zdqlscale(ngrid,nlayermx,nq)
+      real zdqslscale(ngrid,nq)
+      real zdqchim(ngrid,nlayermx,nq)
+      real zdqschim(ngrid,nq)
+
+      real zdteuv(ngrid,nlayermx)    ! (K/s)
+      real zdtconduc(ngrid,nlayermx) ! (K/s)
+      real zdumolvis(ngrid,nlayermx)
+      real zdvmolvis(ngrid,nlayermx)
+      real zdqmoldiff(ngrid,nlayermx,nq)
 
 !     Local variables for local calculations:
-      real zflubid(ngridmx)
-      real zplanck(ngridmx),zpopsk(ngridmx,nlayermx)
-      real zdum1(ngridmx,nlayermx)
-      real zdum2(ngridmx,nlayermx)
+      real zflubid(ngrid)
+      real zplanck(ngrid),zpopsk(ngrid,nlayermx)
+      real zdum1(ngrid,nlayermx)
+      real zdum2(ngrid,nlayermx)
       real ztim1,ztim2,ztim3, z1,z2
       real ztime_fin
-      real zdh(ngridmx,nlayermx)
+      real zdh(ngrid,nlayermx)
       integer length
       parameter (length=100)
@@ -270,13 +265,13 @@
 ! local variables only used for diagnostics (output in file "diagfi" or "stats")
 ! ------------------------------------------------------------------------------
-      real ps(ngridmx), zt(ngridmx,nlayermx)
-      real zu(ngridmx,nlayermx),zv(ngridmx,nlayermx)
-      real zq(ngridmx,nlayermx,nqmx)
+      real ps(ngrid), zt(ngrid,nlayermx)
+      real zu(ngrid,nlayermx),zv(ngrid,nlayermx)
+      real zq(ngrid,nlayermx,nq)
       character*2 str2
       character*5 str5
-      real zdtadj(ngridmx,nlayermx)
-      real zdtdyn(ngridmx,nlayermx),ztprevious(ngridmx,nlayermx)
-      save ztprevious 
-      real reff(ngridmx,nlayermx) ! effective dust radius (used if doubleq=T)
+      real zdtadj(ngrid,nlayermx)
+      real zdtdyn(ngrid,nlayermx)
+      real,allocatable,dimension(:,:),save :: ztprevious
+      real reff(ngrid,nlayermx) ! effective dust radius (used if doubleq=T)
       real qtot1,qtot2            ! total aerosol mass
       integer igmin, lmin
@@ -285,12 +280,11 @@
       real zplev(ngrid,nlayermx+1),zplay(ngrid,nlayermx)
       real zstress(ngrid), cd
-      real hco2(nqmx), tmean, zlocal(nlayermx)
-      real vmr(ngridmx,nlayermx) ! volume mixing ratio
+      real hco2(nq), tmean, zlocal(nlayermx)
+      real vmr(ngrid,nlayermx) ! volume mixing ratio
 
       real time_phys
 
 !     reinstated by RW for diagnostic
-      real tau_col(ngridmx)
-      save tau_col
+      real,allocatable,dimension(:),save :: tau_col
       
 !     included by RW to reduce insanity of code
@@ -298,34 +292,34 @@
 
 !     included by RW to compute tracer column densities
-      real qcol(ngridmx,nqmx)
+      real qcol(ngrid,nq)
 
 !     included by RW for H2O precipitation
-      real zdtrain(ngridmx,nlayermx)
-      real zdqrain(ngridmx,nlayermx,nqmx)
-      real zdqsrain(ngridmx)
-      real zdqssnow(ngridmx)
-      real rainout(ngridmx)
+      real zdtrain(ngrid,nlayermx)
+      real zdqrain(ngrid,nlayermx,nq)
+      real zdqsrain(ngrid)
+      real zdqssnow(ngrid)
+      real rainout(ngrid)
 
 !     included by RW for H2O Manabe scheme
-      real dtmoist(ngridmx,nlayermx)
-      real dqmoist(ngridmx,nlayermx,nqmx)
-
-      real qvap(ngridmx,nlayermx)
-      real dqvaplscale(ngridmx,nlayermx)
-      real dqcldlscale(ngridmx,nlayermx)
-      real rneb_man(ngridmx,nlayermx)
-      real rneb_lsc(ngridmx,nlayermx)
+      real dtmoist(ngrid,nlayermx)
+      real dqmoist(ngrid,nlayermx,nq)
+
+      real qvap(ngrid,nlayermx)
+      real dqvaplscale(ngrid,nlayermx)
+      real dqcldlscale(ngrid,nlayermx)
+      real rneb_man(ngrid,nlayermx)
+      real rneb_lsc(ngrid,nlayermx)
 
 !     included by RW to account for surface cooling by evaporation
-      real dtsurfh2olat(ngridmx)
+      real dtsurfh2olat(ngrid)
 
 
 !     to test energy conservation (RW+JL)
-      real mass(ngridmx,nlayermx),massarea(ngridmx,nlayermx)
+      real mass(ngrid,nlayermx),massarea(ngrid,nlayermx)
       real dEtot, dEtots, AtmToSurf_TurbFlux
       real dEtotSW, dEtotsSW, dEtotLW, dEtotsLW
-      real dEzRadsw(ngridmx,nlayermx),dEzRadlw(ngridmx,nlayermx),dEzdiff(ngridmx,nlayermx)
-      real dEdiffs(ngridmx),dEdiff(ngridmx)
-      real madjdE(ngridmx), lscaledE(ngridmx)
+      real dEzRadsw(ngrid,nlayermx),dEzRadlw(ngrid,nlayermx),dEzdiff(ngrid,nlayermx)
+      real dEdiffs(ngrid),dEdiff(ngrid)
+      real madjdE(ngrid), lscaledE(ngrid)
 !JL12 conservation test for mean flow kinetic energy has been disabled temporarily
       
@@ -333,11 +327,11 @@
 
 !     included by BC for evaporation     
-      real qevap(ngridmx,nlayermx,nqmx)
-      real tevap(ngridmx,nlayermx)
-      real dqevap1(ngridmx,nlayermx)
-      real dtevap1(ngridmx,nlayermx)
+      real qevap(ngrid,nlayermx,nq)
+      real tevap(ngrid,nlayermx)
+      real dqevap1(ngrid,nlayermx)
+      real dtevap1(ngrid,nlayermx)
 
 !     included by BC for hydrology
-      real hice(ngridmx)
+      real hice(ngrid)
 
 !     included by RW to test water conservation (by routine)
@@ -349,9 +343,9 @@
 
 !     included by RW for RH diagnostic
-      real qsat(ngridmx,nlayermx), RH(ngridmx,nlayermx), H2Omaxcol(ngridmx),psat_tmp
+      real qsat(ngrid,nlayermx), RH(ngrid,nlayermx), H2Omaxcol(ngrid),psat_tmp
 
 !     included by RW for hydrology
-      real dqs_hyd(ngridmx,nqmx)
-      real zdtsurf_hyd(ngridmx)
+      real dqs_hyd(ngrid,nq)
+      real zdtsurf_hyd(ngrid)
 
 !     included by RW for water cycle conservation tests
@@ -360,10 +354,10 @@
 !     included by BC for double radiative transfer call
       logical clearsky
-      real zdtsw1(ngridmx,nlayermx)
-      real zdtlw1(ngridmx,nlayermx)
-      real fluxsurf_lw1(ngridmx)     
-      real fluxsurf_sw1(ngridmx)  
-      real fluxtop_lw1(ngridmx)    
-      real fluxabs_sw1(ngridmx)  
+      real zdtsw1(ngrid,nlayermx)
+      real zdtlw1(ngrid,nlayermx)
+      real fluxsurf_lw1(ngrid)     
+      real fluxsurf_sw1(ngrid)  
+      real fluxtop_lw1(ngrid)    
+      real fluxabs_sw1(ngrid)  
       real tau_col1(ngrid)
       real OLR_nu1(ngrid,L_NSPECTI)
@@ -372,15 +366,14 @@
 
 !     included by BC for cloud fraction computations
-      real,save :: cloudfrac(ngridmx,nlayermx)
-      real,save :: totcloudfrac(ngridmx)
+      real,allocatable,dimension(:,:),save :: cloudfrac
+      real,allocatable,dimension(:),save :: totcloudfrac
 
 !     included by RW for vdifc water conservation test
       real nconsMAX
-      real vdifcncons(ngridmx)
-      real cadjncons(ngridmx)
-
-!      double precision qsurf_hist(ngridmx,nqmx)
-      real qsurf_hist(ngridmx,nqmx)
-      save qsurf_hist
+      real vdifcncons(ngrid)
+      real cadjncons(ngrid)
+
+!      double precision qsurf_hist(ngrid,nq)
+      real,allocatable,dimension(:,:),save :: qsurf_hist
 
 !     included by RW for temp convadj conservation test
@@ -392,18 +385,19 @@
 
 !     included by RW for runway greenhouse 1D study
-      real muvar(ngridmx,nlayermx+1)
+      real muvar(ngrid,nlayermx+1)
 
 !     included by RW for variable H2O particle sizes
-      real,save :: reffrad(ngridmx,nlayermx,naerkind) ! aerosol effective radius (m)
-      real,save :: nueffrad(ngridmx,nlayermx,naerkind) ! aerosol effective radius variance
-      real :: reffh2oliq(ngridmx,nlayermx) ! liquid water particles effective radius (m)
-      real :: reffh2oice(ngridmx,nlayermx) ! water ice particles effective radius (m)
-      real reffH2O(ngridmx,nlayermx)
-      real reffcol(ngridmx,naerkind)
+      real,allocatable,dimension(:,:,:),save :: reffrad ! aerosol effective radius (m)
+      real,allocatable,dimension(:,:,:),save :: nueffrad ! aerosol effective radius variance
+      real :: nueffrad_dummy(ngrid,nlayermx,naerkind) !! AS. This is temporary. Check below why.
+      real :: reffh2oliq(ngrid,nlayermx) ! liquid water particles effective radius (m)
+      real :: reffh2oice(ngrid,nlayermx) ! water ice particles effective radius (m)
+      real reffH2O(ngrid,nlayermx)
+      real reffcol(ngrid,naerkind)
 
 !     included by RW for sourceevol
-      real, save :: ice_initial(ngridmx)!, isoil
+      real,allocatable,dimension(:),save :: ice_initial
       real delta_ice,ice_tot
-      real, save :: ice_min(ngridmx)
+      real,allocatable,dimension(:),save :: ice_min
       
       integer num_run
@@ -411,5 +405,42 @@
       
 !=======================================================================
-      
+
+      !!! ALLOCATE SAVED ARRAYS
+      IF (.not. ALLOCATED(tsurf)) ALLOCATE(tsurf(ngrid))
+      IF (.not. ALLOCATED(tsoil)) ALLOCATE(tsoil(ngrid,nsoilmx))    
+      IF (.not. ALLOCATED(albedo)) ALLOCATE(albedo(ngrid))          
+      IF (.not. ALLOCATED(albedo0)) ALLOCATE(albedo0(ngrid))          
+      IF (.not. ALLOCATED(rnat)) ALLOCATE(rnat(ngrid))         
+      IF (.not. ALLOCATED(emis)) ALLOCATE(emis(ngrid))   
+      IF (.not. ALLOCATED(dtrad)) ALLOCATE(dtrad(ngrid,nlayermx))
+      IF (.not. ALLOCATED(fluxrad_sky)) ALLOCATE(fluxrad_sky(ngrid))
+      IF (.not. ALLOCATED(fluxrad)) ALLOCATE(fluxrad(ngrid))    
+      IF (.not. ALLOCATED(capcal)) ALLOCATE(capcal(ngrid))    
+      IF (.not. ALLOCATED(fluxgrd)) ALLOCATE(fluxgrd(ngrid))  
+      IF (.not. ALLOCATED(qsurf)) ALLOCATE(qsurf(ngrid,nq))  
+      IF (.not. ALLOCATED(q2)) ALLOCATE(q2(ngrid,nlayermx+1)) 
+      IF (.not. ALLOCATED(ztprevious)) ALLOCATE(ztprevious(ngrid,nlayermx))
+      IF (.not. ALLOCATED(cloudfrac)) ALLOCATE(cloudfrac(ngrid,nlayermx))
+      IF (.not. ALLOCATED(totcloudfrac)) ALLOCATE(totcloudfrac(ngrid))
+      IF (.not. ALLOCATED(qsurf_hist)) ALLOCATE(qsurf_hist(ngrid,nq))
+      IF (.not. ALLOCATED(reffrad)) ALLOCATE(reffrad(ngrid,nlayermx,naerkind))
+      IF (.not. ALLOCATED(nueffrad)) ALLOCATE(nueffrad(ngrid,nlayermx,naerkind))
+      IF (.not. ALLOCATED(ice_initial)) ALLOCATE(ice_initial(ngrid))
+      IF (.not. ALLOCATED(ice_min)) ALLOCATE(ice_min(ngrid)) 
+
+      IF (.not. ALLOCATED(fluxsurf_lw)) ALLOCATE(fluxsurf_lw(ngrid))
+      IF (.not. ALLOCATED(fluxsurf_sw)) ALLOCATE(fluxsurf_sw(ngrid))
+      IF (.not. ALLOCATED(fluxtop_lw)) ALLOCATE(fluxtop_lw(ngrid))
+      IF (.not. ALLOCATED(fluxabs_sw)) ALLOCATE(fluxabs_sw(ngrid))
+      IF (.not. ALLOCATED(fluxtop_dn)) ALLOCATE(fluxtop_dn(ngrid))
+      IF (.not. ALLOCATED(fluxdyn)) ALLOCATE(fluxdyn(ngrid))
+      IF (.not. ALLOCATED(OLR_nu)) ALLOCATE(OLR_nu(ngrid,L_NSPECTI))
+      IF (.not. ALLOCATED(OSR_nu)) ALLOCATE(OSR_nu(ngrid,L_NSPECTV))
+      IF (.not. ALLOCATED(sensibFlux)) ALLOCATE(sensibFlux(ngrid))
+      IF (.not. ALLOCATED(zdtlw)) ALLOCATE(zdtlw(ngrid,nlayermx))
+      IF (.not. ALLOCATED(zdtsw)) ALLOCATE(zdtsw(ngrid,nlayermx))
+      IF (.not. ALLOCATED(tau_col)) ALLOCATE(tau_col(ngrid))
+
+!=======================================================================
 
 ! 1. Initialisation
@@ -420,4 +451,9 @@
       if (firstcall) then
 
+         print*,'FIRSTCALL INITIALIZATION'
+
+         !! this is defined in comsaison_h
+         ALLOCATE(mu0(ngrid))
+         ALLOCATE(fract(ngrid))
 
 !        variables set to 0
@@ -438,5 +474,5 @@
          tracerdyn=tracer
          if (tracer) then
-            call initracer()
+            call initracer(ngrid,nq,nametrac)
          endif ! end tracer
 
@@ -445,5 +481,5 @@
 !        read startfi (initial parameters)
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-         call phyetat0("startfi.nc",0,0,nsoilmx,nq,           &
+         call phyetat0(ngrid,"startfi.nc",0,0,nsoilmx,nq,   &
                day_ini,time_phys,tsurf,tsoil,emis,q2,qsurf,   &
                cloudfrac,totcloudfrac,hice)
@@ -461,5 +497,5 @@
 !        Initialize albedo and orbital calculation
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-         call surfini(ngrid,qsurf,albedo0)
+         call surfini(ngrid,nq,qsurf,albedo0)
          call iniorbit(apoastr,periastr,year_day,peri_day,obliquit)
 
@@ -474,5 +510,5 @@
 !        ~~~~~~~~~~~~~~~
          if (callsoil) then
-            call soil(ngrid,nsoilmx,firstcall,inertiedat,     &
+            call soil(ngrid,nsoilmx,firstcall,lastcall,inertiedat, &
                 ptimestep,tsurf,tsoil,capcal,fluxgrd)
          else
@@ -506,5 +542,5 @@
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          rnat(:)=1
-         do ig=1,ngridmx
+         do ig=1,ngrid
 !            if(iceball.or.oceanball.or.(inertiedat(ig,1).gt.1.E4))then
             if(inertiedat(ig,1).gt.1.E4)then
@@ -562,4 +598,6 @@
                             ! need epsi for the wvp definitions in callcorrk.F
 
+         print*,'end FIRSTCALL INITIALIZATION'
+
       endif        !  (end of "if firstcall")
 
@@ -568,25 +606,19 @@
 ! ---------------------------------------------------
 
-      if (ngrid.NE.ngridmx) then
-         print*,'STOP in PHYSIQ'
-         print*,'Probleme de dimensions :'
-         print*,'ngrid     = ',ngrid
-         print*,'ngridmx   = ',ngridmx
-         stop
-      endif
+      print*,'ALL INITIALIZATION'
 
 !     Initialize various variables
 !     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-      pdu(1:ngridmx,1:nlayermx) = 0.0
-      pdv(1:ngridmx,1:nlayermx) = 0.0
+      pdu(1:ngrid,1:nlayermx) = 0.0
+      pdv(1:ngrid,1:nlayermx) = 0.0
       if ( .not.nearco2cond ) then
-         pdt(1:ngridmx,1:nlayermx) = 0.0
+         pdt(1:ngrid,1:nlayermx) = 0.0
       endif
-      pdq(1:ngridmx,1:nlayermx,1:nqmx) = 0.0
-      pdpsrf(1:ngridmx)       = 0.0
-      zflubid(1:ngridmx)      = 0.0
-      zdtsurf(1:ngridmx)      = 0.0
-      dqsurf(1:ngridmx,1:nqmx)= 0.0
+      pdq(1:ngrid,1:nlayermx,1:nq) = 0.0
+      pdpsrf(1:ngrid)       = 0.0
+      zflubid(1:ngrid)      = 0.0
+      zdtsurf(1:ngrid)      = 0.0
+      dqsurf(1:ngrid,1:nq)= 0.0
 
       zday=pday+ptime ! compute time, in sols (and fraction thereof)
@@ -603,8 +635,8 @@
 !     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-      zzlay(1:ngridmx,1:nlayermx)=pphi(1:ngridmx,1:nlayermx)/g
-
-      zzlev(1:ngridmx,1)=0.
-      zzlev(1:ngridmx,nlayer+1)=1.e7    ! dummy top of last layer above 10000 km...
+      zzlay(1:ngrid,1:nlayermx)=pphi(1:ngrid,1:nlayermx)/g
+
+      zzlev(1:ngrid,1)=0.
+      zzlev(1:ngrid,nlayer+1)=1.e7    ! dummy top of last layer above 10000 km...
 
       do l=2,nlayer
@@ -621,5 +653,5 @@
 
       do l=1,nlayer         
-         do ig=1,ngrid 
+         do ig=1,ngrid
             zpopsk(ig,l)=(pplay(ig,l)/pplev(ig,1))**rcp
             zh(ig,l)=pt(ig,l)/zpopsk(ig,l)
@@ -628,4 +660,6 @@
          enddo
       enddo
+
+      print*,'end ALL INITIALIZATION'
 
 !-----------------------------------------------------------------------
@@ -684,5 +718,5 @@
                       zdtlw,zdtsw,fluxsurf_lw,fluxsurf_sw,fluxtop_lw,    &
                       fluxabs_sw,fluxtop_dn,OLR_nu,OSR_nu,               &
-                      reffrad,tau_col,cloudfrac,totcloudfrac,            &
+                      reffrad,nueffrad,tau_col,cloudfrac,totcloudfrac,   &
                       clearsky,firstcall,lastcall)      
 
@@ -698,5 +732,5 @@
                       zdtlw1,zdtsw1,fluxsurf_lw1,fluxsurf_sw1,fluxtop_lw1, &
                       fluxabs_sw1,fluxtop_dn,OLR_nu1,OSR_nu1,              &
-                      reffrad,tau_col1,cloudfrac,totcloudfrac,             &
+                      reffrad,nueffrad,tau_col1,cloudfrac,totcloudfrac,    &
                       clearsky,firstcall,lastcall)
                  clearsky = .false.  ! just in case.     
@@ -725,14 +759,14 @@
 !             Radiative flux from the sky absorbed by the surface (W.m-2)
               GSR=0.0
-              fluxrad_sky(1:ngridmx)=emis(1:ngridmx)*fluxsurf_lw(1:ngridmx)+fluxsurf_sw(1:ngridmx)*(1.-albedo(1:ngridmx))
+              fluxrad_sky(1:ngrid)=emis(1:ngrid)*fluxsurf_lw(1:ngrid)+fluxsurf_sw(1:ngrid)*(1.-albedo(1:ngrid))
 
               if(noradsurf)then ! no lower surface; SW flux just disappears
-                 GSR = SUM(fluxsurf_sw(1:ngridmx)*area(1:ngridmx))/totarea
-                 fluxrad_sky(1:ngridmx)=emis(1:ngridmx)*fluxsurf_lw(1:ngridmx)
+                 GSR = SUM(fluxsurf_sw(1:ngrid)*area(1:ngrid))/totarea
+                 fluxrad_sky(1:ngrid)=emis(1:ngrid)*fluxsurf_lw(1:ngrid)
                  print*,'SW lost in deep atmosphere = ',GSR,' W m^-2'
               endif
 
 !             Net atmospheric radiative heating rate (K.s-1)
-              dtrad(1:ngridmx,1:nlayermx)=zdtsw(1:ngridmx,1:nlayermx)+zdtlw(1:ngridmx,1:nlayermx)
+              dtrad(1:ngrid,1:nlayermx)=zdtsw(1:ngrid,1:nlayermx)+zdtlw(1:ngrid,1:nlayermx)
 
            elseif(newtonian)then
@@ -740,7 +774,7 @@
 !          b) Call Newtonian cooling scheme
 !          ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-              call newtrelax(mu0,sinlat,zpopsk,pt,pplay,pplev,dtrad,firstcall)
-
-              zdtsurf(1:ngridmx) = +(pt(1:ngridmx,1)-tsurf(1:ngridmx))/ptimestep
+              call newtrelax(ngrid,mu0,sinlat,zpopsk,pt,pplay,pplev,dtrad,firstcall)
+
+              zdtsurf(1:ngrid) = +(pt(1:ngrid,1)-tsurf(1:ngrid))/ptimestep
               ! e.g. surface becomes proxy for 1st atmospheric layer ?
 
@@ -749,15 +783,15 @@
 !          c) Atmosphere has no radiative effect
 !          ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-              fluxtop_dn(1:ngridmx)  = fract(1:ngridmx)*mu0(1:ngridmx)*Fat1AU/dist_star**2
+              fluxtop_dn(1:ngrid)  = fract(1:ngrid)*mu0(1:ngrid)*Fat1AU/dist_star**2
               if(ngrid.eq.1)then ! / by 4 globally in 1D case...
                  fluxtop_dn(1)  = fract(1)*Fat1AU/dist_star**2/2.0
               endif
-              fluxsurf_sw(1:ngridmx) = fluxtop_dn(1:ngridmx)
-              fluxrad_sky(1:ngridmx) = fluxtop_dn(1:ngridmx)*(1.-albedo(1:ngridmx))
-              fluxtop_lw(1:ngridmx)  = emis(1:ngridmx)*sigma*tsurf(1:ngridmx)**4
+              fluxsurf_sw(1:ngrid) = fluxtop_dn(1:ngrid)
+              fluxrad_sky(1:ngrid) = fluxtop_dn(1:ngrid)*(1.-albedo(1:ngrid))
+              fluxtop_lw(1:ngrid)  = emis(1:ngrid)*sigma*tsurf(1:ngrid)**4
               ! radiation skips the atmosphere entirely
 
 
-              dtrad(1:ngridmx,1:nlayermx)=0.0
+              dtrad(1:ngrid,1:nlayermx)=0.0
               ! hence no atmospheric radiative heating
 
@@ -765,13 +799,13 @@
 
         endif ! of if(mod(icount-1,iradia).eq.0)
-
+       
 
 !    Transformation of the radiative tendencies
 !    ------------------------------------------
 
-        zplanck(1:ngridmx)=tsurf(1:ngridmx)*tsurf(1:ngridmx)
-        zplanck(1:ngridmx)=emis(1:ngridmx)*sigma*zplanck(1:ngridmx)*zplanck(1:ngridmx)
-        fluxrad(1:ngridmx)=fluxrad_sky(1:ngridmx)-zplanck(1:ngridmx)
-        pdt(1:ngridmx,1:nlayermx)=pdt(1:ngridmx,1:nlayermx)+dtrad(1:ngridmx,1:nlayermx)
+        zplanck(1:ngrid)=tsurf(1:ngrid)*tsurf(1:ngrid)
+        zplanck(1:ngrid)=emis(1:ngrid)*sigma*zplanck(1:ngrid)*zplanck(1:ngrid)
+        fluxrad(1:ngrid)=fluxrad_sky(1:ngrid)-zplanck(1:ngrid)
+        pdt(1:ngrid,1:nlayermx)=pdt(1:ngrid,1:nlayermx)+dtrad(1:ngrid,1:nlayermx)
 
 !-------------------------
@@ -794,4 +828,5 @@
 !-------------------------
 
+      print*,'end RADIATIVE TRANSFER'
       endif ! of if (callrad)
 
@@ -802,8 +837,8 @@
       if (calldifv) then
       
-         zflubid(1:ngridmx)=fluxrad(1:ngridmx)+fluxgrd(1:ngridmx)
-
-         zdum1(1:ngridmx,1:nlayermx)=0.0
-         zdum2(1:ngridmx,1:nlayermx)=0.0
+         zflubid(1:ngrid)=fluxrad(1:ngrid)+fluxgrd(1:ngrid)
+
+         zdum1(1:ngrid,1:nlayermx)=0.0
+         zdum2(1:ngrid,1:nlayermx)=0.0
 
 
@@ -821,5 +856,5 @@
 	 else
 	 
-           zdh(1:ngridmx,1:nlayermx)=pdt(1:ngridmx,1:nlayermx)/zpopsk(1:ngridmx,1:nlayermx)
+           zdh(1:ngrid,1:nlayermx)=pdt(1:ngrid,1:nlayermx)/zpopsk(1:ngrid,1:nlayermx)
  
            call vdifc(ngrid,nlayer,nq,rnat,zpopsk,   &
